#include <string.h>
#include <stdio.h>
#include <sys/time.h>

#include "blowfish.h"

static unsigned char *plaintext = "7654321 Now is the time for ";
static unsigned char iv[8] = {0xFE,0xDC,0xBA,0x98,0x76,0x54,0x32,0x10};
static unsigned char key[16] = {0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef,0xf0,0xe1,0xd2,0xc3,0xb4,0xa5,0x96,0x87};

main()
{
unsigned char a[32],b[16],a2[32];
BF_KEY k;
unsigned long l1,l2;
unsigned long i;
struct timeval start,stop;
long elapsed;
double s;

bzero(a,32);
bcopy(plaintext,a,29);
bcopy(iv,b,8);
BF_set_key(&k,16,key);
printf("\n output = ");
for(i=0;i<32;i++) printf("%02x",a[i]);
printf("\n");
#if 1
blowfish_cbc_encrypt(a,32,&k,b,1);
#endif
printf("\n output = ");
for(i=0;i<32;i++) printf("%02x",a[i]);
printf("\n");
bcopy(iv,b,8);
#if 1
blowfish_cbc_encrypt(a,32,&k,b,0);
#endif
printf("\n output = ");
for(i=0;i<32;i++) printf("%02x",a[i]);
printf("\n");
#if 1
  printf("starting blowfish time trial, 1,000,000 encryptions\n");
  gettimeofday(&start,NULL);
  for(i=0;i<1000000;i++)
/*    Blowfish_encipher (&k, &((unsigned long *)a)[0],&((unsigned long *)a)[1]); */
blowfish_cbc_encrypt(a,8,&k,b,1);
  gettimeofday(&stop,NULL);

        elapsed = 1000*(stop.tv_sec - start.tv_sec) + (stop.tv_usec - start.tv_usec)/1000.;
        printf("execution time = %ld ms\n",elapsed);
        s = 1000.*1000000./elapsed;
        printf("%.1lf crypts/sec %.1lf bytes/sec %.1lf bits/sec",s,s*8,s*64);
        return 0;

#endif
}
