/* sha.h */

#ifndef _SHA_H_
#define _SHA_H_

/* define the following line to get FIPS 180-1 enhancements */
#define SHA_UPDATE

#define SHABLOCKLEN  64		/* in bytes */
#define SHAHASHLEN   20		/* in bytes */

typedef unsigned char BYTE;
typedef unsigned long ULONG;

typedef struct {
    ULONG Numbytes;
    ULONG Numblocks[2];  /* each block contains 64 bytes */
    ULONG Mblock[16];
    ULONG buffer[5];
} SHA_CTX;

#if defined(MSDOS) || defined(KERNEL)
#define PROTO
#endif

#ifdef __STDC__
#define PROTO
#endif

int SHAInit(SHA_CTX *shaContext);
int SHAUpdate( SHA_CTX *shaContext, BYTE *buffer, int bytecount);
int SHAFinal( SHA_CTX *shaContext);

#endif /*_SHA_H_*/
